//+----------------------------------------------------------------------------+
//|                                                      a-SimpleTrailing.mqh  |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  17.11.2005      .                  |
//|                  :                       |
//|              -    : #include <a-SimpleTrailing.mqh>          |
//|              -   start(): if (UseTrailing) TrailingPositions();    |
//+----------------------------------------------------------------------------+

//-------    --------------------------------------------+
extern string _P_Trailing = "----------  ";
extern bool UseTrailing      = True;        //  
extern bool ProfitTrailing   = True;        //   
extern int  TrailingStopBuy  = 50;          //   
extern int  TrailingStopSell = 50;          //   
extern int  TrailingStep     = 5;           //  

//+----------------------------------------------------------------------------+
//|                                           |
//|  :                                                                |
//|    sy -     ("" -  )                   |
//|    op -                    (-1 -  )                    |
//|    mn - MagicNumber                (-1 -  )                      |
//+----------------------------------------------------------------------------+
void TrailingPositions(string sy="", int op=-1, int mn=-1) {
  double p, pp;
  int    i, k=OrdersTotal();

  if (sy=="") sy=Symbol();
  p=MarketInfo(sy, MODE_POINT);
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy && (op<0 || OrderType()==op)) {
        if (mn<0 || OrderMagicNumber()==mn) {
          if (OrderType()==OP_BUY) {
            pp=MarketInfo(sy, MODE_BID);
            if (!ProfitTrailing || (pp-OrderOpenPrice())>TrailingStopBuy*p) {
              if (OrderStopLoss()<pp-(TrailingStopBuy+TrailingStep-1)*p) {
                ModifyOrder(sy, -1, pp-TrailingStopBuy*p, 0, clModifyBuy);
              }
            }
          }
          if (OrderType()==OP_SELL) {
            pp=MarketInfo(sy, MODE_ASK);
            if (!ProfitTrailing || OrderOpenPrice()-pp>TrailingStopSell*p) {
              if (OrderStopLoss()>pp+(TrailingStopSell+TrailingStep-1)*p || OrderStopLoss()==0) {
                ModifyOrder(sy, -1, pp+TrailingStopSell*p, 0, clModifySell);
              }
            }
          }
        }
      }
    }
  }
}
//+----------------------------------------------------------------------------+

